(*************************************************************************
*                                                                        *
*    package  EXTERN  from unit  NUMERIK                                 *
*                                                                        *
**************************************************************************
    *                                                                    *
    *  J. Desteffani IA85                     01.01.1987 - 04.02.1987    *
    *                                                                    *
    *  p u r p o s e :                                                   *
    *    Speichert Matrizen aud Diskette ab, oder laedt diese von der    *             *
    *    Diskette in den Ramspeicher.                                    *
    *                                                                    *
    *  e n t r i e s :                                                   *
    *    PROCEDURE do_load;                                              *
    *    PROCEDURE do_save;                                              *
    *                                                                    *
    **********************************************************************)

PROCEDURE load_Extern (Name, Name_Intern :T_Enter_String);

   VAR
      Index  :integer;
      n, m   :real;
      Zeiger :T_Matrix_Zeiger;
      Data   :T_Daten_Zeiger;
      Disk   :file of real;

BEGIN
   assign (Disk, Name + Matrix_Call);
   {$I-}
      reset (Disk);
   {$I+}
   IF IOresult <> 0 THEN BEGIN
      close (Disk);
      N_Error (110);
      exit;
   END;
   Zeiger:= get_Matrix_Zeiger (Name_Intern);
   Zeiger^.Name:= Name_Intern;
   read (Disk, n, m);
   Zeiger^.n:= round(n);
   Zeiger^.m:= round(m);
   Index:= 0;
   new (Data);
   Data^.next:= nil;
   Zeiger^.Wurzel:= Data;
   WHILE not eof (Disk) DO BEGIN
      read (Disk, Data^.Zahl);
      Index:= Index+1;
      IF not eof (Disk) THEN BEGIN
         new (Data^.next);
         Data:= Data^.next;
         Data^.next:= nil;
      END;
   END;
   close (Disk);
   IF Index <> Zeiger^.n * Zeiger^.m THEN BEGIN
      Error_Arg:= Name;
      N_Error (510);
   END;
END;

(*------------------------------------------------------------------------*)

PROCEDURE save_Extern (VAR Argument :T_Enter_String; Zeiger: T_Matrix_Zeiger);

   VAR
       overwrite   :boolean;
       possible    :boolean;
       i           :integer;
       n, m        :real;
       Disk        :File of real;
       d           :T_Daten_Zeiger;

BEGIN
   possible:= false;
   REPEAT
      assign (Disk, Argument + Matrix_Call);
      {$I-}
         reset (Disk);
      {$I+}
      IF IOresult = 0 THEN BEGIN
         Message_String_1:= Argument;
         overwrite:= N_Ask (3);
         IF not overwrite THEN BEGIN
            close (Disk);
            Argument:= N_String_Ask (10);
         END;
      END
      ELSE BEGIN
         possible:= true;
      END;
   UNTIL (possible) or (overwrite);
   rewrite (Disk);
   n:= Zeiger^.n;
   m:= Zeiger^.m;
   d:= Zeiger^.Wurzel;
   write (Disk, n);
   write (Disk, m);
   FOR i:= 1 TO (Zeiger^.n * Zeiger^.m) DO BEGIN
      write (Disk, d^.Zahl);
      d:= d^.next;
   END;
   close (Disk);
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_load;
BEGIN
   IF Eingabe.Arg[3] = '' THEN BEGIN
      Eingabe.Arg[3]:= Eingabe.Arg[2];
   END;
   Load_Extern (Eingabe.Arg[2], Eingabe.Arg[3]);
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_save;

   VAR
      x     :T_Matrix_Zeiger;
      safe  :T_Enter_String;

BEGIN
   CASE Eingabe.Art OF
   1,2,7:BEGIN
         Message_String_1:= Eingabe.Arg[2];
         N_Message(16);
         IF Eingabe.Arg[3] = '' THEN BEGIN
            safe:= Eingabe.Arg[2];
         END
         ELSE BEGIN
            safe:= Eingabe.Arg[3];
         END;
         save_Extern (safe, Eingabe.Nr[2]);
         IF safe <> Eingabe.Arg[2] THEN BEGIN
            Message_String_1:= safe;
            N_Message(16);
         END;
      END;
   5 :BEGIN
         IF not N_Ask (7) THEN BEGIN
            N_Message(11);
            exit;
         END;
         N_Message(10);
         x:= Matrizen;
         IF x <> nil THEN BEGIN
            WHILE x <> nil DO BEGIN
               save_Extern (x^.Name, x);
               x:= x^.next;
            END;
            N_Message (40);
         END
         ELSE BEGIN
            N_Error (210);
         END;
      END;
   END;
END;
