(*************************************************************************
*                                                                        *
*    procedure  LAGRANGE  from  package  NUMERIK                         *
*                                                                        *
**************************************************************************
    *                                                                    *
    *  J. Desteffani IA85                     27.01.1987 - 27.01.1987    *
    *                                                                    *
    *  p u r p o s e :                                                   *
    *    Berechnet Tabellenwerte des Interpolationspolynoms.             *
    *    (siehe Numerik - 7.1.2)                                         *
    *                                                                    *
    *  e n t r i e s :                                                   *
    *    PROCEDURE do_lagrange;                                          *
    *                                                                    *
    **********************************************************************)

PROCEDURE do_lagrange;

   VAR
      Error               :boolean;
      source, points      :T_Tabelle;
      low, high, step     :real;
      number_of_points, s :integer;


   FUNCTION get_Wert (z :real): real;

      VAR
         on    :boolean;
         s, f  :real;
         i, k  :integer;
         l     :T_Vektor;

   BEGIN
      i:= 1;
      REPEAT
         on:= (z = source.x[i,1]);
         IF on THEN get_Wert:= source.x[i,2];
         i:= i+1;
      UNTIL (on) or (i = source.n +1);
      IF on THEN BEGIN
         exit;
      END
      ELSE BEGIN
         s:= 0;
         f:= 0;
         l[1]:= 1;
         FOR k:= 2 TO Source.n DO BEGIN
            l[k]:= 0;
            FOR i:= 1 TO k-1 DO BEGIN
               IF source.x[i,1] = source.x[k,1] THEN BEGIN
                  Error:= true;
                  exit;
               END;
               l[i]:= l[i]/(source.x[i,1] - source.x[k,1]);
               l[k]:= l[k] - l[i];
            END;
         END;
         FOR k:= 1 TO source.n DO BEGIN
            l[k]:= l[k]/(z - source.x[k,1]);
            s:= s + l[k]*source.x[k,2];
            f:= f + l[k];
         END;
         get_Wert:= s/f;
      END;
   END;


BEGIN
   Load_Intern_Tabelle (Eingabe.Nr[2], source);
   IF (source.m <> 2) THEN BEGIN
      N_Error (67);
      exit;
   END;
   low:= N_real_Ask (10);
   high:= N_real_Ask (11);
   IF high < low THEN BEGIN
      N_Error (28);
      exit;
   END;
   number_of_points:= N_integer_Ask (10);
   points.Name:= Result_Name;
   points.n:= number_of_points;
   points.m:= 2;
   step:= (high - low)/(number_of_points - 1);
   Error:= false;
   FOR s:= 1 TO number_of_points DO BEGIN
      points.x[s,1]:= low;
      points.x[s,2]:= get_Wert (low);
      low:= low + step;
      IF Error THEN BEGIN
         N_Error(70);
         exit;
      END;
   END;
   save_Intern_Tabelle (points);
   N_Message (9);
END;

