(*************************************************************************
*                                                                        *
*    Package   LIST   from   NUMERIK                                     *
*                                                                        *
**************************************************************************
    *                                                                    *
    *  J. Desteffani IA85                     01.01.1987 - 26.01.1987    *
    *                                                                    *
    *  p u r p o s e :                                                   *
    *    Listet intern gespeicherte Matrizen auf.                        *
    *    Moeglich ist ein oberflaechliches Listing mit (-,0,+) oder ein  *
    *    explizites Listing.                                             *
    *    Proceduren zur Umspeicherung von Matrizen ebenfalls imple -     *
    *    mentiert.                                                       *
    *                                                                    *
    *  e n t r i e s :                                                   *
    *    PROCEDURE do_list;                                              *
    *    PROCEDURE list_matrix  (x_matrix :T_Matrix_Zeiger);             *
    *    PROCEDURE do_lr;                                                *
    *    PROCEDURE do_display;                                           *
    *                                                                    *
    **********************************************************************)

FUNCTION go_on (VAR Zeile :integer): boolean;
BEGIN
   Zeile:= Zeile + 1;
   IF Zeile >= 21 THEN BEGIN
      IF N_Ask(1) THEN BEGIN
         Zeile:= 1;
         writeln;
         go_on:= true;
      END
      ELSE BEGIN
         go_on:= false;
      END;
   END
   ELSE BEGIN
      writeln;
      go_on:= true;
   END;
END;

(*------------------------------------------------------------------------*)

PROCEDURE list_matrix;   (* (x_matrix :T_Matrix_Zeiger); *)

   VAR
      x_data      :T_Daten_Zeiger;
      i, j, Zeile :integer;

BEGIN
   Zeile:= 1;
   x_data:= x_matrix^.Wurzel;
   FOR i:= 1 TO x_matrix^.n DO BEGIN
      IF not go_on (Zeile) THEN exit;
      write (i:2, ' | ');
      FOR j:= 1 TO x_matrix^.m DO BEGIN
         IF (Format in [kurz, kurz_exp]) THEN BEGIN
            IF (j<>1) and ((j-1)/7 = int ((j-1)/7)) THEN BEGIN
               IF not go_on (Zeile) THEN exit;
               write ('     ');
            END
         END
         ELSE BEGIN
            IF (j<>1) and ((j-1)/4 = int ((j-1)/4)) THEN BEGIN
               IF not go_on (Zeile) THEN exit;
               write ('     ');
            END;
         END;
         IF x_data = nil THEN BEGIN
            N_Error (520);
            exit;
         END;
         write_formated (x_data^.Zahl);
         x_data:= x_data^.next;
         write ('  ');
      END;
   END;
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_list;

  VAR
      x_matrix   :T_Matrix_Zeiger;
      Zeile      :integer;

BEGIN
   IF Eingabe.Art = 1 THEN BEGIN
      List_Matrix (Eingabe.Nr[2]);
   END
   ELSE BEGIN
      Zeile:= 1;
      x_matrix:= Matrizen;
      IF x_matrix = nil THEN BEGIN
         N_Error (210);
         exit;
      END;
      REPEAT
         IF not go_on (Zeile) THEN exit;
         Message_String_1:= x_matrix^.Name;
         N_Message (16);
         gotoXY (15, whereY);
         write ('lines:', x_matrix^.n:3, '   columns:', x_matrix^.m:3);
         x_matrix:= x_matrix^.next;
      UNTIL x_matrix = nil;
   END;
END;

PROCEDURE do_lr;

   VAR
      Zeiger   :T_Matrix_Zeiger;

BEGIN
   IF Matrizen <> nil THEN BEGIN
      Eingabe.Art:= 1;
      Zeiger:= Matrizen;
      REPEAT
         IF Zeiger^.Name = Result_Name THEN BEGIN
            Eingabe.Nr[2]:= Zeiger;
            do_list;
            exit;
         END;
         Zeiger:= Zeiger^.next;
      UNTIL (Zeiger = nil);
   END;
   N_Error (220);
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_display;

   VAR
      i, j   :integer;
      Zahl   :real;

BEGIN
   Load_Intern (Eingabe.Nr[2], M1);
   writeln;
   FOR i:= 1 TO M1.n DO BEGIN
      IF (i/20 = int (i/20)) THEN IF not N_Ask(1) THEN exit;
      writeln;
      write (i:3, ' | ');
      FOR j:= 1 TO M1.m DO BEGIN
         Zahl:= M1.x[i,j];
         IF abs(Zahl) <= epsilon THEN write ('0');
         IF Zahl > epsilon THEN write ('+');
         IF Zahl < -epsilon THEN write ('-');
      END;
   END;
END;

