(*************************************************************************
*                                                                        *
*    package  MATRIX-MOVE  from  unit  NUMERIK                           *
*                                                                        *
**************************************************************************
    *                                                                    *
    *  J. Desteffani IA85                     01.01.1987 - 26.01.1987    *
    *                                                                    *
    *  p u r p o s e :                                                   *
    *    Dieses Package fuehrt verschiedene einfache Operationen         *
    *    einzelner Matrizen aus.                                         *
    *                                                                    *
    *  e n t r i e s :                                                   *
    *    PROCEDURE do_clear;                                             *
    *    PROCEDURE do_delete;                                            *
    *    PROCEDURE do_edit;                                              *
    *    PROCEDURE do_input;                                             *
    *                                                                    *
    **********************************************************************)

PROCEDURE do_clear;

(* .........................................................................
   .                                                                       .
   . Diese Procedure setzt alle Elemente der mit (Eingabe.Arg[2])          .
   . spezifizierten Matrix auf 0.0.                                        .
   .                                                                       .
   .........................................................................
*)

   VAR
      i, j  :integer;

BEGIN
   load_Intern (Eingabe.Nr[2], M1);
   FOR i:= 1 TO M1.n DO BEGIN
      FOR j:= 1 TO M1.m DO BEGIN
         M1.x[i,j]:= 0;
      END;
   END;
   save_Intern (M1);
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_del;

(* .........................................................................
   .                                                                       .
   . loescht je nachdem ob eine Matrix spezifiziert wurde oder nicht,      .
   . alle oder nur die spezifizierte aus dem internen Speicher.            .
   .                                                                       .
   .........................................................................
*)
   VAR
      x      :T_Matrix_Zeiger;

BEGIN
   CASE Eingabe.Art OF
   1: BEGIN
         x:= Matrizen;
         WHILE x <> nil DO BEGIN
            IF x^.Name = Eingabe.Arg[2] THEN BEGIN
               Del_Intern (x);
               N_Message (12);
               exit;
            END
            ELSE BEGIN
               x:= x^.next;
            END;
         END;
         N_Error (520);
      END;
   5: BEGIN
         IF Matrizen <> nil THEN BEGIN
            IF N_Ask(6) THEN BEGIN
               N_Message (10);
               WHILE Matrizen <> nil DO BEGIN
                  Del_Intern (Matrizen);
               END;
               N_Message (41);
            END
            ELSE BEGIN
               N_Message (11);
            END;
         END
         ELSE BEGIN
            N_Error (211);
         END;
      END;
   END;
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_edit;

(* .........................................................................
   .                                                                       .
   . Ermoeglicht das edieren einer bestehenden Matrix.                     .
   . Es wird nach dem Anfangsindex gefragt. Von diesem Index an ist dann   .
   . dann ein Edieren moeglich. Mit Return ist ein Abbruch des Ediervor -  .
   . ganges moeglich.                                                      .
   .........................................................................
*)

   VAR
      go_on         :boolean;
      i, ii, j, jj  :integer;
      edmat         :T_Matrix_Intern;

BEGIN
   Load_Intern (Eingabe.Nr[2], edmat);
   ii:= N_integer_Ask (13);
   jj:= N_integer_Ask (14);
   IF (ii > edmat.n) or (jj > edmat.m) THEN BEGIN
      N_Error (28);
      exit;
   END;
   i:= ii;
   j:= jj;
   REPEAT
      REPEAT
         Message_integer_1:= i;
         Message_integer_2:= j;
         N_Message (19);
         go_on:= N_Ask (30);
         IF go_on THEN edmat.x[i,j]:= input_real;
         j:= j + 1;
      UNTIL (not go_on) or (j > edmat.m);
      j:= 1;
      i:= i + 1;
   UNTIL (not go_on) or (i > edmat.n);
   Save_Intern (edmat);
   N_Message (9);
END;

(*------------------------------------------------------------------------*)

PROCEDURE do_input;

(* .........................................................................
   .                                                                       .
   . Die Eingabe einer Matrix wird mit dieser Procedure ermoeglicht.       .
   . Es ist moeglich die Eingabe mittendrinn abzubrechen. (Mit Return)     .
   . Die nicht eingegebenen Elemente werden auf 0.0 gesetzt.               .
   .                                                                       .
   .........................................................................
*)

   VAR
      break, really :boolean;
      i, j          :integer;
      Inp           :T_Matrix_Intern;

BEGIN
   break:= false;
   Inp.n:= N_integer_Ask (11);
   Inp.m:= N_integer_Ask (12);
   Inp.Name:= Eingabe.Arg[2];
   IF (Inp.n in [1..max_Ind]) and (Inp.m in [1..max_Ind]) THEN BEGIN
      FOR i:= 1 TO Inp.n DO BEGIN
         FOR j:= 1 TO Inp.m DO BEGIN
            Inp.x[i,j]:= 0;
            IF not break THEN BEGIN
               Message_integer_1:= i;
               Message_integer_2:= j;
               N_Message (19);
               Input_real:= 0.0;
               REPEAT
                  IF not N_Ask (30) THEN BEGIN
                     really:= N_Ask (8);
                     IF really THEN break:= true;
                  END
                  ELSE BEGIN
                     Inp.x[i,j]:= Input_real;
                     really:= true;
                  END;
               UNTIL really;
            END;
         END;
      END;
      Message_integer_1:= Inp.n;
      Message_integer_2:= Inp.m;
      N_Message (19);
      save_Intern (Inp);
      N_Message (9);
   END
   ELSE BEGIN
      N_Error (40);
   END;
END;
