(*************************************************************************
*                                                                        *
*    PROCEDURE   Plot   from  NUMERIK                                    *
*                                                                        *
**************************************************************************
    *                                                                    *
    *  J. Desteffani IA85                     01.01.1987 - 06.02.1987    *
    *                                                                    *
    *  p u r p o s e :                                                   *
    *    Plotet eine Tabelle auf eine einfache Art und Weise auf den     *
    *    Bildschirm. Die Koordinatenachsen koennen veraendert werden.    *
    *    Die Koordinatenachsen werden, wenn sie auf den Schirm zu liegen *
    *    kommen, angezeigt                                               *
    *                                                                    *
    *  e n t r i e s :                                                   *
    *    PROCEDURE do_plot;                                              *
    *                                                                    *
    **********************************************************************)


PROCEDURE Do_Plot;

   TYPE
      T_choosed_pointer  = ^T_choosed_matrizen;
      T_choosed_matrizen = RECORD
                              sign  :char;
                              wer   :T_matrix_zeiger;
                              next  :T_choosed_pointer;
                           END;

   VAR
      end_of_plot     :boolean;
      P_error         :boolean;
      the_choose      :char;
      x_min, x_max,
      y_min, y_max    :real;
      erster          :T_choosed_pointer;
      xy_table        :T_tabelle;

(*------------------------------------------------------------------------*)

   PROCEDURE Plot_Tables;

      VAR
         px, py, i :integer;
         who_now   :T_choosed_pointer;


      FUNCTION Get_X (x: real): integer;
         VAR
            temp   :real;
      BEGIN
         get_x:= 0;
         IF x_min = x_max THEN BEGIN
            get_x:= 40;
         END
         ELSE BEGIN
            temp:= 78/(x_max-x_min) * (x-x_min) + 1;
            IF abs(temp) < 1000 THEN get_x:= round(temp);
         END;
      END;


      FUNCTION Get_Y (y: real): integer;
         VAR
            temp   :real;
      BEGIN
         get_y:= 0;
         IF y_min = y_max THEN BEGIN
            get_y:= 10;
         END
         ELSE BEGIN
            temp:= 20/(y_max-y_min) * (y-y_min);
            IF abs(temp) < 1000 THEN get_y:= 21 - round(temp);
         END;
      END;


      PROCEDURE Goto_And_Plot (x, y :integer; Zeichen :char);
      BEGIN
         IF (x in [1..79]) and (y in [1..21]) THEN BEGIN
            gotoXY (x,y);
            write (Zeichen);
         END;
      END;


   BEGIN
      ClrScr;
      (* Koordinatenachsen *)
      px:= Get_X (0);
      py:= Get_Y (0);
      FOR i:= 1 TO 79 DO BEGIN
         Goto_And_Plot (i, py, char(196));
      END;
      FOR i:= 1 TO 21 DO BEGIN
         Goto_And_Plot (px, i, char(179));
      END;
      Goto_And_Plot (px, py, char(197));
      (* Tabellen *)
      who_now:= erster;
      REPEAT
         Load_Intern_Tabelle (who_now^.wer, xy_table);
         WITH xy_table DO BEGIN
            FOR i:= 1 TO n DO BEGIN
               px:= get_x (x[i,1]);
               py:= get_y (x[i,2]);
               Goto_And_Plot (px, py, who_now^.sign);
            END;
         END;
         who_now:= who_now^.next;
      UNTIL who_now = nil;
   END;

(*------------------------------------------------------------------------*)

   PROCEDURE Get_Another_Table;
      VAR
         new_name    :T_enter_string;
         new_pointer :T_matrix_zeiger;
         search      :T_choosed_pointer;
   BEGIN
      new_name:= N_String_Ask (15);
      new_pointer:= Argument_Test (new_name);
      IF new_pointer = nil THEN BEGIN
         p_error:= true;
      END
      ELSE BEGIN
         search:= erster;
         WHILE search^.next <> nil DO search:= search^.next;
         new (search^.next);
         search:= search^.next;
         search^.next:= nil;
         search^.sign:= N_Char_Ask (10);
         search^.wer:= new_pointer
      END;
   END;

(*------------------------------------------------------------------------*)

   PROCEDURE Get_Optimal_Borders;

      VAR
         i          :integer;
         wx, wy     :real;
         who        :T_choosed_pointer;
         xy_table   :T_Tabelle;

   BEGIN
      who:= erster;
      Load_Intern_Tabelle (who^.wer, xy_table);
      x_min:= xy_table.x[1,1];
      x_max:= x_min;
      y_min:= xy_table.x[1,2];
      y_max:= y_min;
      WHILE who <> nil DO BEGIN
         WITH xy_table DO BEGIN
            Load_Intern_Tabelle (who^.wer, xy_table);
            FOR i:= 2 TO n DO BEGIN
               wx:= x[i,1];
               wy:= x[i,2];
               IF (wx > x_max) THEN x_max:= wx;
               IF (wx < x_min) THEN x_min:= wx;
               IF (wy > y_max) THEN y_max:= wy;
               IF (wy < y_min) THEN y_min:= wy;
            END;
         END;
         who:= who^.next;
      END;
   END;

(*------------------------------------------------------------------------*)

   PROCEDURE Get_New_Borders;
      VAR
         new_x_min, new_x_max, new_y_min, new_y_max  :real;
   BEGIN
      new_x_min:= x_min;
      new_x_max:= x_max;
      new_y_min:= y_min;
      new_y_max:= y_max;
      IF N_Ask (50) THEN new_x_min:= input_real;
      IF N_Ask (51) THEN new_x_max:= input_real;
      IF N_Ask (52) THEN new_y_min:= input_real;
      IF N_Ask (53) THEN new_y_max:= input_real;
      IF (new_x_min <= new_x_max) and (new_y_min <= new_y_max) THEN BEGIN
         x_min:= new_x_min;
         x_max:= new_x_max;
         y_min:= new_y_min;
         y_max:= new_y_max;
      END
      ELSE BEGIN
         p_error:= true;
      END;
   END;

(*------------------------------------------------------------------------*)

   FUNCTION Get_Menue_Choose: char;

      VAR
         who_now    :T_choosed_pointer;

   BEGIN
      ClrScr;
      who_now:= erster;
      gotoXY (55,6);
      WHILE who_now <> nil DO BEGIN
         message_string_1:= who_now^.wer^.name;
         N_Message (16);
         gotoXY (65, whereY);
         write ('`', who_now^.sign, '`');
         gotoXY (55, whereY + 1);
         who_now:= who_now^.next;
      END;
      gotoXY (1,3);
      writeln ('         min                max                          tables');
      writeln ('         ---                ---                          ------');
      writeln;
      write ('(x)  ');
      Write_Formated (x_min);
      GotoXY (25, WhereY);
      Write_Formated (x_max);
      writeln;
      write ('(y)  ');
      Write_Formated (y_min);
      GotoXY (25, WhereY);
      Write_Formated (y_max);
      writeln;
      writeln;
      writeln;
      writeln;
      writeln ('menu');
      writeln ('----');
      writeln;
      writeln ('(a)  other axes');
      writeln ('(o)  optimal axes');
      writeln ('(t)  additional table to plot');
      writeln ('(p)  plot');
      writeln ('(e)  exit');
      IF p_error THEN BEGIN
         writeln;
         write ('ERROR');
      END;
      get_menue_choose:= N_Char_Ask (20);
   END;

(*------------------------------------------------------------------------*)

   PROCEDURE Dispose_Pointers;
      VAR
         clear_one, new_one  :T_choosed_pointer;
   BEGIN
      clear_one:= erster;
      WHILE clear_one <> nil DO BEGIN
         new_one:= clear_one^.next;
         dispose (clear_one);
         clear_one:= new_one;
      END;
   END;

(*------------------------------------------------------------------------*)

BEGIN
   end_of_plot:= false;
   P_error:= false;
   new (erster);
   erster^.sign:= '*';
   erster^.wer:= eingabe.nr[2];
   erster^.next:= nil;
   Get_Optimal_Borders;
   REPEAT
      the_choose:= Get_Menue_Choose;
      P_error:= false;
      CASE the_choose OF
      'a':BEGIN
             Get_New_Borders;
          END;
      'o':BEGIN
             Get_Optimal_Borders;
          END;
      't':BEGIN
             Get_Another_Table;
          END;
      'p':BEGIN
             Plot_Tables;
             N_Message (98);
          END;
      'e':BEGIN
             end_of_plot:= true;
          END;
      END;
   UNTIL end_of_plot;
   Dispose_Pointers;
END;
